import { delegateEvents as $e, render as ut, createComponent as c, hydrate as ft, getNextElement as m, getNextMarker as h, use as qe, spread as mt, mergeProps as pt, insert as p, runHydrationEvents as ve, effect as pe, setAttribute as Be, memo as gt, template as k } from "solid-js/web";
import { syntaxTree as de, syntaxHighlighting as Te, HighlightStyle as Oe } from "@codemirror/language";
import { RangeSetBuilder as Pe, SelectionRange as kt, EditorSelection as ht, Compartment as ye, EditorState as bt, StateField as xt, RangeSet as ne } from "@codemirror/state";
import { defaultKeymap as vt, historyKeymap as yt, history as wt } from "@codemirror/commands";
import { Decoration as B, ViewPlugin as Ve, EditorView as W, keymap as Mt } from "@codemirror/view";
import { markdown as Ie, markdownLanguage as _e } from "@codemirror/lang-markdown";
import { languages as We } from "@codemirror/language-data";
import { tags as u, Tag as St } from "@lezer/highlight";
import { createContext as Ct, createSignal as _, Show as x, useContext as Lt, onMount as Ne, onCleanup as jt, For as zt, createEffect as Bt } from "solid-js";
import { defineComponent as Dt, openBlock as At, createElementBlock as Et } from "vue";
const Ht = "data-ink-mde-ssr-hydration-marker", $t = `[${Ht}]`, qt = () => ({}), Tt = ([e]) => {
  const { editor: t } = e();
  t.destroy();
}, ge = ([e]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, Re = (e) => {
  const t = e.map((n) => kt.fromJSON({ anchor: n.start, head: n.end }));
  return ht.create(t);
}, Fe = (e) => e.ranges.map((t) => ({
  end: t.anchor < t.head ? t.head : t.anchor,
  start: t.head < t.anchor ? t.head : t.anchor
}));
var ae = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(ae || {}), v = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(v || {}), ke = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(ke || {});
const De = {
  auto: "auto",
  dark: "dark",
  light: "light"
}, N = {
  completion: "completion",
  default: "default",
  grammar: "grammar",
  language: "language"
}, E = (e) => ({ block: !1, line: !1, multiline: !1, nodes: [], prefix: "", prefixStates: [], suffix: "", ...e }), Ot = {
  [v.Bold]: E({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [v.Code]: E({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [v.CodeBlock]: E({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [v.Heading]: E({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [v.Image]: E({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [v.Italic]: E({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [v.Link]: E({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [v.OrderedList]: E({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [v.Quote]: E({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [v.TaskList]: E({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [v.List]: E({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, Pt = ({ editor: e, selection: t }) => {
  let n = t.start;
  const r = [];
  for (; n <= t.end; ) {
    const o = e.lineBlockAt(n), i = Math.max(t.start, o.from), s = Math.min(t.end, o.to);
    r.push({ start: i, end: s }), n = o.to + 1;
  }
  return r;
}, Vt = ({ editor: e, formatDefinition: t, selection: n }) => {
  var s, a;
  if (!e || !t)
    return n || { start: 0, end: 0 };
  const r = n || Fe(e.state.selection).pop() || { start: 0, end: 0 };
  if (t.block || t.line || t.multiline) {
    const l = e.lineBlockAt(r.start).from, d = e.lineBlockAt(r.end).to;
    return { start: l, end: d };
  }
  const o = ((s = e.state.wordAt(r.start)) == null ? void 0 : s.from) || r.start, i = ((a = e.state.wordAt(r.end)) == null ? void 0 : a.to) || r.end;
  return { start: o, end: i };
}, Ue = (e) => e.editor.state.sliceDoc(e.selection.start, e.selection.end), It = (e, t, n) => _t(e, n).find(({ type: r }) => t.nodes.includes(r.name)), _t = (e, t) => {
  const n = [];
  return de(e.state).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: r, from: o, to: i }) => {
      n.push({ type: r, from: o, to: i });
    }
  }), n;
}, we = (e) => {
  const t = Ue(e), n = e.formatDefinition.prefix.length, r = e.formatDefinition.suffix.length * -1 || t.length, o = t.slice(n, r);
  return [{ from: e.selection.start, to: e.selection.end, insert: o }];
}, Wt = (e) => {
  if (e.node) {
    const t = e.node.from, n = e.node.to;
    return we({ ...e, selection: { start: t, end: n } });
  } else {
    const t = e.formatDefinition.prefix, n = e.formatDefinition.suffix;
    return [
      { from: e.selection.start, insert: t },
      { from: e.selection.end, insert: n }
    ];
  }
}, Nt = (e) => {
  const t = Pt(e), n = [];
  return t.forEach((r) => {
    const o = Qe({ ...e, selection: r });
    n.push(...o);
  }), n;
}, Qe = (e) => {
  const t = e.formatDefinition.prefixStates.length > 0, n = Ue(e);
  if (e.node && t) {
    const r = e.formatDefinition.prefixStates.find((o) => n.startsWith(o));
    if (r) {
      const o = e.formatDefinition.prefixStates.indexOf(r), i = e.formatDefinition.prefixStates[o + 1], s = n.replace(new RegExp(`^${r}`), i);
      return [{ from: e.selection.start, to: e.selection.end, insert: s }];
    }
  } else if (e.node && n.startsWith(e.formatDefinition.prefix))
    return we(e);
  return [{ from: e.selection.start, insert: e.formatDefinition.prefix }];
}, Rt = (e) => {
  if (e.node) {
    const t = e.node.from, n = e.node.to;
    return we({ ...e, selection: { start: t, end: n } });
  } else {
    const { formatDefinition: t, selection: n } = e, r = Array.isArray(t.prefix) ? t.prefix[0] : t.prefix, o = t.suffix;
    return [
      { from: n.start, insert: r },
      { from: n.end, insert: o }
    ];
  }
}, Ft = (e) => e.formatDefinition.block ? Wt(e) : e.formatDefinition.multiline ? Nt(e) : e.formatDefinition.line ? Qe(e) : Rt(e), Xe = ([e], t, { selection: n } = {}) => {
  const { editor: r } = e(), o = Ot[t], i = Vt({ editor: r, formatDefinition: o, selection: n }), s = It(r, o, i), a = Ft({
    editor: r,
    formatDefinition: o,
    node: s,
    selection: i
  }), l = a.reduce((f, w) => {
    const j = w.insert.length - ((w.to || w.from) - w.from);
    return f + j;
  }, 0), d = e().editor.state.update({ changes: a, selection: { head: i.start, anchor: i.end + l } });
  e().editor.dispatch(d);
}, Ut = ([e]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, Me = ([e]) => {
  const { editor: t } = e();
  return Fe(t.state.selection);
}, ce = ([e, t], n, r, o = !1) => {
  const { editor: i } = e();
  let s = r == null ? void 0 : r.start, a = (r == null ? void 0 : r.end) || (r == null ? void 0 : r.start);
  if (typeof s > "u") {
    const d = Me([e, t]).pop();
    s = d.start, a = d.end;
  }
  const l = { changes: { from: s, to: a, insert: n } };
  if (o) {
    const d = s === a ? s + n.length : s, f = s + n.length;
    Object.assign(l, { selection: { anchor: d, head: f } });
  }
  i.dispatch(
    i.state.update(l)
  );
}, I = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, Qt = (e) => {
  if (Object.prototype.toString.call(e) === I.object)
    return `[object ${e.constructor.name}]`;
}, F = (e, t) => Qt(e) === t, Xt = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), r = (o, i) => n.get(o) || (F(o, I.object) && n.set(o, !0), F(i, I.undefined)) ? o : F(o, I.array) && F(i, I.array) ? [...i] : F(o, I.object) && F(i, I.object) ? Object.keys(o).reduce((s, a) => (Object.hasOwnProperty.call(i, a) ? s[a] = r(o[a], i[a]) : s[a] = o[a], s), {}) : i;
  return r(e, t);
}, ee = (e, t) => Xt(e, t), Ae = () => document.createElement("div"), Ke = () => window.matchMedia("(prefers-color-scheme: dark)").matches, Kt = (e) => e === ae.Dark ? !0 : e === ae.Light ? !1 : Ke(), me = (e) => {
  const t = [
    // --ink-*
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    // --ink-block-*
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    // --ink-code-*
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    // --ink-editor-*
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    // --ink-modal-*
    { suffix: "modal-position", default: "fixed" },
    // --ink-syntax-*
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" },
    { suffix: "toolbar-group-spacing", default: "2rem" },
    { suffix: "toolbar-item-spacing", default: "0" }
  ], n = !Kt(e.options.interface.appearance);
  return t.map((r) => {
    const o = n && r.light ? r.light : r.default;
    return `--ink-internal-${r.suffix}: var(--ink-${r.suffix}, ${o});`;
  });
}, Yt = {
  array: "[object Array]",
  asyncFunction: "[object AsyncFunction]",
  boolean: "[object Boolean]",
  function: "[object Function]",
  null: "[object Null]",
  number: "[object Number]",
  object: "[object Object]",
  promise: "[object Promise]",
  string: "[object String]",
  symbol: "[object Symbol]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, Zt = (e, t) => Object.prototype.toString.call(t) === e, Ye = (e) => Zt(Yt.promise, e), ue = (e) => en(e, Ye), Jt = (e, t) => t.type === e, Gt = (e, t) => !!e && e in t, U = (e, t) => Ze(t.plugins).reduce((n, r) => (Jt(e, r) && (!r.key || Gt(r.key, t) && t[r.key]) && n.push(r.value), n), []), Ze = (e) => e.reduce((t, n) => Array.isArray(n) ? t.concat(Ze(n)) : t.concat(n), []), en = (e, t) => e.reduce((n, r) => (t(r) ? n[0].push(r) : n[1].push(r), n), [[], []]), tn = (e) => [
  W.theme({}, { dark: e })
], nn = ([e, t]) => {
  const n = [], [r, o] = rn(e().options), [i, s] = on(e().options);
  return Math.max(r.length, i.length) > 0 && e().workQueue.enqueue(async () => {
    const a = await fe([e, t]);
    e().editor.dispatch({ effects: a });
  }), Ie({
    base: _e,
    codeLanguages: [...We, ...s],
    extensions: [...n, ...o]
  });
}, rn = (e) => ue(U(N.grammar, e)), on = (e) => ue(U(N.language, e)), an = async ([e]) => {
  const t = [], n = await Promise.all(U(N.grammar, e().options)), r = await Promise.all(U(N.language, e().options));
  return Ie({
    base: _e,
    codeLanguages: [...We, ...r],
    extensions: [...t, ...n]
  });
}, ln = () => {
  const e = new ye();
  return {
    compartment: e,
    initialValue: (t) => e.of(nn(t)),
    reconfigure: async (t) => e.reconfigure(await an(t))
  };
}, sn = ([e, t]) => e().extensions.map(
  (n) => n.initialValue([e, t])
), fe = async ([
  e,
  t
]) => await Promise.all(
  e().extensions.map(async (n) => await n.reconfigure([e, t]))
), dn = (e) => {
  const t = new ye();
  return {
    compartment: t,
    initialValue: (n) => t.of(e(n)),
    reconfigure: (n) => t.reconfigure(e(n))
  };
}, cn = (e) => {
  const t = new ye();
  return {
    compartment: t,
    initialValue: () => t.of([]),
    reconfigure: (n) => e(n, t)
  };
}, un = () => [
  ln(),
  ...fn.map((e) => dn(e)),
  ...mn.map((e) => cn(e))
], fn = [
  ([e]) => {
    const [t, n] = ue(
      U(N.default, e().options)
    );
    return n;
  },
  ([e]) => {
    const t = e().options.interface.appearance === De.dark, n = e().options.interface.appearance === De.auto;
    return tn(t || n && Ke());
  }
], mn = [
  async ([e], t) => {
    const [n] = ue(
      U(N.default, e().options)
    );
    return n.length > 0 ? t.reconfigure(await Promise.all(n)) : t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.interface.autocomplete) {
      const { autocomplete: n } = await import("./autocomplete-561a6e3c-44aa7a52.js");
      return t.reconfigure(n(e().options));
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.interface.images) {
      const { images: n } = await import("./images-1efb4104-6c2da5f4.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    const { keybindings: n, trapTab: r } = e().options, o = r ?? n.tab, i = r ?? n.shiftTab;
    if (o || i) {
      const { indentWithTab: s } = await import("./indentWithTab-9c25ee81-d18e3476.js");
      return t.reconfigure(s({ tab: o, shiftTab: i }));
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.interface.lists) {
      const { lists: n } = await import("./lists-d36e2bb8-6fbd6d68.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.placeholder) {
      const { placeholder: n } = await import("./placeholder-985d86f2-985d86f2.js");
      return t.reconfigure(n(e().options.placeholder));
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.interface.readonly) {
      const { readonly: n } = await import("./readonly-28fcecea-55be0157.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.search) {
      const { search: n } = await import("./search-9c46866b-76220770.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.interface.spellcheck) {
      const { spellcheck: n } = await import("./spellcheck-9deeebb9-d0e98cfa.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async ([e], t) => {
    if (e().options.vim.open) {
      const { vim: n } = await import("./vim-d360ff62-41f2fcb1.js");
      return t.reconfigure(n(e().options.vim));
    }
    return t.reconfigure([]);
  }
], pn = [
  "Blockquote"
], gn = B.line({ attributes: { class: "cm-blockquote" } }), kn = B.line({ attributes: { class: "cm-blockquote-open" } }), hn = B.line({ attributes: { class: "cm-blockquote-close" } }), bn = Ve.define((e) => ({
  update: () => xn(e)
}), { decorations: (e) => e.update() }), xn = (e) => {
  const t = new Pe(), n = de(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      n.iterate({
        enter({ type: s, from: a, to: l }) {
          if (s.name !== "Document" && pn.includes(s.name)) {
            t.add(i.from, i.from, gn);
            const d = e.state.doc.lineAt(a), f = e.state.doc.lineAt(l);
            return d.number === i.number && t.add(i.from, i.from, kn), f.number === i.number && t.add(i.from, i.from, hn), !1;
          }
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, vn = () => [
  bn
], yn = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], Q = {
  // Prevent spellcheck in all code blocks. The Grammarly extension might not respect these values.
  "data-enable-grammarly": "false",
  "data-gramm": "false",
  "data-grammarly-skip": "true",
  spellcheck: "false"
}, wn = B.line({ attributes: { ...Q, class: "cm-codeblock" } }), Mn = B.line({ attributes: { ...Q, class: "cm-codeblock-open" } }), Sn = B.line({ attributes: { ...Q, class: "cm-codeblock-close" } }), Cn = B.mark({ attributes: { ...Q, class: "cm-code" } }), Ln = B.mark({ attributes: { ...Q, class: "cm-code cm-code-open" } }), jn = B.mark({ attributes: { ...Q, class: "cm-code cm-code-close" } }), zn = Ve.define((e) => ({
  update: () => Bn(e)
}), { decorations: (e) => e.update() }), Bn = (e) => {
  const t = new Pe(), n = de(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      let s;
      n.iterate({
        enter({ type: a, from: l, to: d }) {
          if (a.name !== "Document")
            if (yn.includes(a.name)) {
              t.add(i.from, i.from, wn);
              const f = e.state.doc.lineAt(l), w = e.state.doc.lineAt(d);
              return f.number === i.number && t.add(i.from, i.from, Mn), w.number === i.number && t.add(i.from, i.from, Sn), !1;
            } else
              a.name === "InlineCode" ? s = { from: l, to: d, innerFrom: l, innerTo: d } : a.name === "CodeMark" && (l === s.from ? (s.innerFrom = d, t.add(l, d, Ln)) : d === s.to && (s.innerTo = l, t.add(s.innerFrom, s.innerTo, Cn), t.add(l, d, jn)));
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, Dn = () => [
  zn
], An = () => [
  W.editorAttributes.of({
    class: "ink-mde-container"
  }),
  W.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
  // Todo: Maybe open a PR to add scrollerAttributes?
], En = () => [
  ...An()
], Hn = () => W.lineWrapping, $n = () => [
  Te(
    Oe.define([
      // ordered by lowest to highest precedence
      {
        tag: u.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: u.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      // emphasis types
      {
        tag: u.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: u.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: u.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      // comment group
      {
        tag: u.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      // monospace
      {
        tag: u.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      // name group
      {
        tag: u.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: u.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: u.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: u.definition(u.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: u.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: u.definition(u.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: u.local(u.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: u.special(u.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      // headings
      {
        tag: u.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: u.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: u.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: u.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: u.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: u.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: u.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      // contextual tag types
      {
        tag: u.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: u.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: u.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: u.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: u.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: u.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      // string group
      {
        tag: u.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: u.special(u.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      // processing instructions
      {
        tag: u.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], qn = (e) => {
  if (e.length > 0)
    return Re(e);
}, Je = ([e, t]) => bt.create({
  doc: e().options.doc,
  selection: qn(e().options.selections),
  extensions: [
    Mt.of([
      ...vt,
      ...yt
    ]),
    vn(),
    Dn(),
    wt(),
    En(),
    Hn(),
    $n(),
    ...sn([e, t])
  ]
}), Tn = ([e, t], n) => {
  t(ee(e(), { options: { doc: n } })), e().editor.setState(Je([e, t]));
}, On = ([e]) => e().options, Pn = async ([e, t], n) => {
  const { workQueue: r } = e();
  return r.enqueue(async () => {
    t(ee(e(), { options: n }));
    const o = await fe([e, t]);
    e().editor.dispatch({ effects: o });
  });
}, Ge = (e, t = {}) => {
  if (t.selections)
    return et(e, t.selections);
  if (t.selection)
    return he(e, t.selection);
  if (t.at)
    return Vn(e, t.at);
}, Vn = (e, t) => {
  const [n] = e;
  if (t === ke.Start)
    return he(e, { start: 0, end: 0 });
  if (t === ke.End) {
    const r = n().editor.state.doc.length;
    return he(e, { start: r, end: r });
  }
}, et = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      selection: Re(t)
    })
  );
}, he = (e, t) => et(e, [t]), In = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      changes: {
        from: 0,
        to: n.state.doc.length,
        insert: t
      }
    })
  );
}, _n = ([e, t], { after: n, before: r, selection: o }) => {
  const { editor: i } = e(), s = o || Me([e, t]).pop() || { start: 0, end: 0 }, a = i.state.sliceDoc(s.start, s.end);
  ce([e, t], `${r}${a}${n}`, s), Ge([e, t], { selections: [{ start: s.start + r.length, end: s.end + r.length }] });
}, Wn = (e, t) => {
  const n = {
    callbacks: {
      fulfilled: [],
      rejected: [],
      settled: []
    },
    status: "pending"
  }, r = (a, { resolve: l, reject: d }) => () => {
    try {
      const f = a(n.value);
      Promise.resolve(f).then(l, d);
    } catch (f) {
      d(f);
    }
  }, o = (a) => {
    n.status === "pending" && (n.status = "rejected", n.value = a, n.callbacks.rejected.forEach((l) => l()), n.callbacks.settled.forEach((l) => l()));
  }, i = (a) => {
    n.status === "pending" && (n.status = "fulfilled", n.value = a, n.callbacks.fulfilled.forEach((l) => l()), n.callbacks.settled.forEach((l) => l()));
  }, s = (a, l) => new Promise((d, f) => {
    n.status === "pending" && (a && n.callbacks.fulfilled.push(r(a, { resolve: d, reject: f })), l && n.callbacks.rejected.push(r(l, { resolve: void 0, reject: f }))), n.status === "fulfilled" && a && r(a, { resolve: d, reject: f })(), n.status === "rejected" && l && r(l, { resolve: void 0, reject: f })();
  });
  return queueMicrotask(() => {
    try {
      t(i, o);
    } catch (a) {
      o(a);
    }
  }), {
    ...e,
    [Symbol.toStringTag]: "awaitable",
    catch: s.bind(void 0, void 0),
    finally: (a) => new Promise((l, d) => {
      n.status === "pending" && n.callbacks.settled.push(r(a, { resolve: l, reject: d })), n.status === "fulfilled" && (a(), l(n.value)), n.status === "rejected" && (a(), d(n.value));
    }),
    then: s
  };
}, tt = (e) => {
  const t = {
    destroy: Tt.bind(void 0, e),
    focus: ge.bind(void 0, e),
    format: Xe.bind(void 0, e),
    getDoc: Ut.bind(void 0, e),
    insert: ce.bind(void 0, e),
    load: Tn.bind(void 0, e),
    options: On.bind(void 0, e),
    reconfigure: Pn.bind(void 0, e),
    select: Ge.bind(void 0, e),
    selections: Me.bind(void 0, e),
    update: In.bind(void 0, e),
    wrap: _n.bind(void 0, e)
  };
  return Wn(t, (n, r) => {
    try {
      const [o] = e;
      o().workQueue.enqueue(() => n(t));
    } catch (o) {
      r(o);
    }
  });
}, Nn = (e, t) => {
  const n = e[t];
  return n ? typeof n == "function" ? n() : Promise.resolve(n) : new Promise((r, o) => {
    (typeof queueMicrotask == "function" ? queueMicrotask : setTimeout)(o.bind(null, new Error("Unknown variable dynamic import: " + t)));
  });
}, re = new Proxy({}, {
  get: (e, t, n) => e[t] ? e[t] : e[t] = (async () => {
    const { importer: r } = await Nn(/* @__PURE__ */ Object.assign({ "./importers/katex.ts": () => import("./katex-5761b211-5761b211.js") }), `./importers/${t}.ts`), o = await r();
    return e[t] = o, o;
  })()
}), Rn = (e, t) => {
  if (!re[e])
    return console.error("[katex] module is not resolvable");
  if ("then" in re[e])
    return Promise.resolve(re[e]).then(t);
  t(re[e]);
}, Fn = (e) => ot({
  block: !0,
  side: -1,
  ...e
}), nt = (e) => B.line({
  ...e,
  type: "line"
}), Un = (e) => B.mark({
  ...e,
  type: "mark"
}), rt = (e) => {
  const t = (n) => e.eq ? e.eq(n) : e.id ? e.id === n.id : !1;
  return {
    compare: (n) => t(n),
    coordsAt: () => null,
    destroy: () => {
    },
    eq: (n) => t(n),
    estimatedHeight: -1,
    ignoreEvent: () => !0,
    lineBreaks: 0,
    toDOM: () => document.createElement("span"),
    updateDOM: () => !1,
    ...e
  };
}, ot = (e) => B.widget({
  block: !1,
  side: 0,
  ...e,
  widget: rt({
    ...e.widget
  }),
  type: "widget"
}), ie = (e, t) => {
  var r, o;
  const n = [];
  return de(e).iterate({
    enter: (i) => {
      if (t.nodes.includes(i.type.name)) {
        const s = t.onMatch(e, i);
        if (!s)
          return;
        Array().concat(s).forEach((a) => {
          if (a.spec.type === "line") {
            const l = nt({ ...a.spec, node: { ...i } });
            for (let d = e.doc.lineAt(i.from); d.from < i.to; d = e.doc.lineAt(d.to + 1))
              n.push(l.range(d.from));
          }
          if (a.spec.type === "mark") {
            const l = Un({ ...a.spec, node: { ...i } }).range(i.from, i.to);
            n.push(l);
          }
          if (a.spec.type === "widget") {
            const l = ot({ ...a.spec, node: { ...i } }).range(i.from);
            n.push(l);
          }
        });
      }
    },
    from: (r = t.range) == null ? void 0 : r.from,
    to: (o = t.range) == null ? void 0 : o.to
  }), n.sort((i, s) => i.from - s.from);
}, Qn = (e, t, n) => {
  const r = [], o = e.iter(), i = [], s = [];
  for (; o.value; )
    i.push({ ...o }), o.next();
  t.changes.iterChangedRanges((l, d, f, w) => {
    i.forEach((M) => {
      if (M.value) {
        const D = M.value.spec.node.to - M.value.spec.node.from, P = M.from, V = M.from + D;
        Xn(P, V, f, w) && s.push(M);
      }
    });
    const j = { from: f, to: w };
    r.push(...ie(t.state, { ...n, range: j }));
  });
  const a = i.filter((l) => !s.includes(l)).flatMap((l) => {
    var f;
    const d = (f = l.value) == null ? void 0 : f.range(l.from);
    return d ? [d] : [];
  });
  return r.push(...a), r.sort((l, d) => l.from - d.from);
}, Xn = (e, t, n, r) => Math.max(e, n) <= Math.min(t, r), Ee = (e) => xt.define({
  create(t) {
    return ne.of(ie(t, e));
  },
  update(t, n) {
    if (n.reconfigured || n.effects.length > 0)
      return ne.of(ie(n.state, e));
    const r = t.map(n.changes);
    return n.docChanged ? e.optimize ? ne.of(Qn(r, n, e)) : ne.of(ie(n.state, e)) : r;
  },
  provide(t) {
    return W.decorations.from(t);
  }
}), Kn = (e) => St.define(e), Yn = (e) => e.charCodeAt(0), X = (e) => Se(e, [u.processingInstruction]), Se = (e, t = []) => {
  const n = Kn();
  return {
    node: er({
      name: e,
      style: [n, ...t]
    }),
    tag: n
  };
}, Zn = (e) => e, Jn = (e) => e, Gn = (e) => e, er = (e) => e, G = {
  dollarSign: Yn("$")
}, tr = /\$.*?\$/, nr = /\$(?<math>.*?)\$/, le = Se("MathInline"), se = X("MathInlineMark"), Ce = X("MathInlineMarkOpen"), Le = X("MathInlineMarkClose"), rr = Jn({
  name: le.node.name,
  parse: (e, t, n) => {
    var s;
    if (t !== G.dollarSign)
      return -1;
    const r = e.slice(n, e.end);
    if (!tr.test(r))
      return -1;
    const o = r.match(nr);
    if (!((s = o == null ? void 0 : o.groups) != null && s.math))
      return -1;
    const i = o.groups.math.length;
    return e.addElement(
      e.elt(
        le.node.name,
        n,
        n + i + 2,
        [
          e.elt(
            se.node.name,
            n,
            n + 1,
            [
              e.elt(
                Ce.node.name,
                n,
                n + 1
              )
            ]
          ),
          e.elt(
            se.node.name,
            n + i + 1,
            n + i + 2,
            [
              e.elt(
                Le.node.name,
                n + i + 1,
                n + i + 2
              )
            ]
          )
        ]
      )
    );
  }
}), it = Se("MathBlock"), be = X("MathBlockMark"), at = X("MathBlockMarkOpen"), lt = X("MathBlockMarkClose"), or = Zn({
  name: "MathBlock",
  parse: (e, t) => {
    if (t.next !== G.dollarSign || t.text.charCodeAt(t.pos + 1) !== G.dollarSign)
      return !1;
    const n = e.lineStart + t.pos, r = n + t.text.length;
    for (; e.nextLine(); )
      if (t.next === G.dollarSign && t.text.charCodeAt(t.pos + 1) === G.dollarSign) {
        const o = e.lineStart + t.pos, i = o + t.text.length;
        e.addElement(
          e.elt(
            it.node.name,
            n,
            i,
            [
              e.elt(
                be.node.name,
                n,
                r,
                [
                  e.elt(
                    at.node.name,
                    n,
                    r
                  )
                ]
              ),
              e.elt(
                be.node.name,
                o,
                i,
                [
                  e.elt(
                    lt.node.name,
                    o,
                    i
                  )
                ]
              )
            ]
          )
        ), e.nextLine();
        break;
      }
    return !0;
  }
}), ir = Gn({
  defineNodes: [
    le.node,
    se.node,
    Le.node,
    Ce.node,
    it.node,
    be.node,
    at.node,
    lt.node
  ],
  parseBlock: [
    or
  ],
  parseInline: [
    rr
  ]
}), He = (e, t) => {
  Rn("katex", (n) => {
    n.render(e, t, { output: "html", throwOnError: !1 });
  });
}, ar = () => [
  J({
    key: "katex",
    type: N.grammar,
    value: async () => ir
  }),
  J({
    key: "katex",
    value: async () => Ee({
      nodes: ["MathBlock", "MathBlockMarkClose", "MathBlockMarkOpen"],
      onMatch: (e, t) => {
        const n = ["ink-mde-line-math-block"];
        return t.name === "MathBlockMarkOpen" && n.push("ink-mde-line-math-block-open"), t.name === "MathBlockMarkClose" && n.push("ink-mde-line-math-block-close"), nt({
          attributes: {
            class: n.join(" ")
          }
        });
      },
      optimize: !1
    })
  }),
  J({
    key: "katex",
    value: async () => Ee({
      nodes: ["MathBlock"],
      onMatch: (e, t) => {
        const n = e.sliceDoc(t.from, t.to).split(`
`).slice(1, -1).join(`
`);
        if (n)
          return Fn({
            widget: rt({
              id: n,
              toDOM: () => {
                const r = document.createElement("div"), o = document.createElement("div");
                return r.className = "ink-mde-block-widget-container", o.className = "ink-mde-block-widget ink-mde-katex-target", r.appendChild(o), He(n, o), r;
              },
              updateDOM: (r) => {
                const o = r.querySelector(".ink-mde-katex-target");
                return o ? (He(n, o), !0) : !1;
              }
            })
          });
      },
      optimize: !1
    })
  }),
  J({
    key: "katex",
    value: async () => Te(
      Oe.define([
        {
          tag: [le.tag, se.tag],
          backgroundColor: "var(--ink-internal-block-background-color)"
        },
        {
          tag: [Le.tag],
          backgroundColor: "var(--ink-internal-block-background-color)",
          borderRadius: "0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0",
          paddingRight: "var(--ink-internal-inline-padding)"
        },
        {
          tag: [Ce.tag],
          backgroundColor: "var(--ink-internal-block-background-color)",
          borderRadius: "var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius)",
          paddingLeft: "var(--ink-internal-inline-padding)"
        }
      ])
    )
  }),
  J({
    key: "katex",
    value: async () => W.theme({
      ".ink-mde-line-math-block": {
        backgroundColor: "var(--ink-internal-block-background-color)",
        padding: "0 var(--ink-internal-block-padding) !important"
      },
      ".ink-mde-line-math-block-open": {
        borderRadius: "var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0"
      },
      ".ink-mde-line-math-block-close": {
        borderRadius: "0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius)"
      }
    })
  })
], lr = () => {
  const e = {
    queue: [],
    workload: 0
  }, t = async () => {
    const n = e.queue.pop();
    n && (await n(), e.workload--, await t());
  };
  return {
    enqueue: (n) => new Promise((r, o) => {
      const i = async () => {
        try {
          await n(), r();
        } catch (s) {
          o(s);
        }
      };
      e.queue.push(i), e.workload++, !(e.workload > 1) && t();
    })
  };
}, xe = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: ae.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      lists: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    katex: !1,
    keybindings: {
      // Todo: Set these to false by default. https://codemirror.net/examples/tab
      tab: !0,
      shiftTab: !0
    },
    placeholder: "",
    plugins: [
      ar()
    ],
    readability: !1,
    search: !0,
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    // This value overrides both `tab` and `shiftTab` keybindings.
    trapTab: void 0,
    vim: !1
  };
  return {
    doc: "",
    editor: {},
    extensions: un(),
    options: e,
    root: Ae(),
    target: Ae(),
    workQueue: lr()
  };
}, sr = (e) => ee(xe(), e), je = (e, t = {}) => {
  const [n, r] = _(sr({ ...t, doc: e.doc || "", options: e }));
  return [n, r];
}, dr = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, cr = /* @__PURE__ */ k("<span>uploading files..."), ur = /* @__PURE__ */ k('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z">'), fr = /* @__PURE__ */ k('<img class="ink-drop-zone-file-preview-image">'), mr = /* @__PURE__ */ k("<span>drop files here"), pr = () => {
  const [e, t] = _(0), [n, r] = _([]), [o, i] = _(!1), [s, a] = _(!1), [l, d] = K(), f = () => {
    a(!1);
  }, w = (b) => {
    if (l().options.files.dragAndDrop) {
      b.preventDefault(), b.stopPropagation();
      const y = b.dataTransfer;
      y != null && y.files ? Y(y.files) : (t(0), a(!1), r([]));
    }
  }, j = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), t(e() + 1), a(!0));
  }, M = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), t(e() - 1), e() === 0 && a(!1));
  }, D = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), a(!0));
  }, P = (b) => {
    l().options.files.dragAndDrop && (b.preventDefault(), t(0), a(!1));
  }, V = (b) => {
    if (l().options.files.clipboard) {
      b.preventDefault();
      const y = b.clipboardData;
      y != null && y.files && y.files.length > 0 && Y(y.files);
    }
  }, Y = (b) => {
    Array.from(b).forEach((y) => {
      r([...n(), y]);
    }), i(!0), a(!0), Promise.resolve(l().options.files.handler(b)).then((y) => {
      if (l().options.files.injectMarkup && y) {
        const Z = `![](${y})`;
        ce([l, d], Z);
      }
    }).finally(() => {
      t(0), i(!1), a(!1), r([]);
    });
  };
  return Ne(() => {
    document.addEventListener("dragenter", j), document.addEventListener("dragleave", M), document.addEventListener("dragover", D), document.addEventListener("drop", P), l().root.addEventListener("paste", V);
  }), jt(() => {
    document.removeEventListener("dragenter", j), document.removeEventListener("dragleave", M), document.removeEventListener("dragover", D), document.removeEventListener("drop", P), l().root.removeEventListener("paste", V);
  }), (() => {
    const b = m(ur), y = b.firstChild, Z = y.nextSibling, R = Z.firstChild, g = R.firstChild, q = g.nextSibling, [C, T] = h(q.nextSibling), O = R.nextSibling;
    return y.textContent = dr, R.addEventListener("drop", w), p(g, c(zt, {
      get each() {
        return n().slice(0, 8);
      },
      children: (S) => (() => {
        const A = m(fr);
        return pe((L) => {
          const H = S.name, $ = URL.createObjectURL(S);
          return H !== L._v$ && Be(A, "alt", L._v$ = H), $ !== L._v$2 && Be(A, "src", L._v$2 = $), L;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), A;
      })()
    })), p(R, c(x, {
      get when() {
        return o();
      },
      get fallback() {
        return m(mr);
      },
      get children() {
        return m(cr);
      }
    }), C, T), O.$$click = f, pe(() => b.classList.toggle("visible", !!s())), ve(), b;
  })();
};
$e(["click"]);
const gr = ([e, t]) => {
  const n = new W({
    dispatch: (r) => {
      const { options: o } = e(), i = r.newDoc.toString();
      o.hooks.beforeUpdate(i), n.update([r]), r.docChanged && (t({ ...e(), doc: i }), o.hooks.afterUpdate(i));
    },
    state: Je([e, t])
  });
  return n;
}, kr = () => {
  const [e, t] = K(), n = gr([e, t]), {
    workQueue: r
  } = e();
  return t(ee(e(), {
    editor: n
  })), r.enqueue(async () => {
    const o = await fe([e, t]);
    n.dispatch({
      effects: o
    });
  }), n.dom;
}, hr = /* @__PURE__ */ k('<button class="ink-button" type="button">'), z = (e) => (() => {
  const t = m(hr);
  return t.$$click = (n) => e.onclick(n), p(t, () => e.children), ve(), t;
})();
$e(["click"]);
const br = `.ink-mde .ink-mde-toolbar{background-color:var(--ink-internal-block-background-color);color:inherit;display:flex;flex-shrink:0;overflow-x:auto;padding:.25rem}.ink-mde .ink-mde-toolbar .ink-mde-container{display:flex;gap:var(--ink-internal-toolbar-group-spacing)}.ink-mde .ink-mde-toolbar-group{display:flex;gap:var(--ink-internal-toolbar-item-spacing)}.ink-mde .ink-mde-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink-mde .ink-mde-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink-mde .ink-mde-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, xr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16">'), vr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10">'), yr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11">'), oe = /* @__PURE__ */ k('<div class="ink-mde-toolbar-group"><!#><!/><!#><!/><!#><!/>'), wr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5">'), Mr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13">'), Sr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6">'), Cr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4">'), Lr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501">'), jr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4">'), zr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999">'), Br = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z">'), Dr = /* @__PURE__ */ k('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13">'), Ar = /* @__PURE__ */ k('<input type="file">'), Er = /* @__PURE__ */ k('<div class="ink-mde-toolbar"><style></style><div class="ink-mde-container"><!#><!/><!#><!/><!#><!/><!#><!/>'), Hr = () => {
  const [e, t] = K(), [n, r] = _(), o = (a) => {
    Xe([e, t], a), ge([e, t]);
  }, i = (a) => {
    const l = a.target;
    l != null && l.files && Promise.resolve(e().options.files.handler(l.files)).then((d) => {
      if (d) {
        const f = `![](${d})`;
        ce([e, t], f), ge([e, t]);
      }
    });
  }, s = () => {
    var a;
    (a = n()) == null || a.click();
  };
  return (() => {
    const a = m(Er), l = a.firstChild, d = l.nextSibling, f = d.firstChild, [w, j] = h(f.nextSibling), M = w.nextSibling, [D, P] = h(M.nextSibling), V = D.nextSibling, [Y, b] = h(V.nextSibling), y = Y.nextSibling, [Z, R] = h(y.nextSibling);
    return l.textContent = br, p(d, c(x, {
      get when() {
        return e().options.toolbar.heading || e().options.toolbar.bold || e().options.toolbar.italic;
      },
      get children() {
        const g = m(oe), q = g.firstChild, [C, T] = h(q.nextSibling), O = C.nextSibling, [S, A] = h(O.nextSibling), L = S.nextSibling, [H, $] = h(L.nextSibling);
        return p(g, c(x, {
          get when() {
            return e().options.toolbar.heading;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Heading),
              get children() {
                return m(xr);
              }
            });
          }
        }), C, T), p(g, c(x, {
          get when() {
            return e().options.toolbar.bold;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Bold),
              get children() {
                return m(vr);
              }
            });
          }
        }), S, A), p(g, c(x, {
          get when() {
            return e().options.toolbar.italic;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Italic),
              get children() {
                return m(yr);
              }
            });
          }
        }), H, $), g;
      }
    }), w, j), p(d, c(x, {
      get when() {
        return e().options.toolbar.quote || e().options.toolbar.codeBlock || e().options.toolbar.code;
      },
      get children() {
        const g = m(oe), q = g.firstChild, [C, T] = h(q.nextSibling), O = C.nextSibling, [S, A] = h(O.nextSibling), L = S.nextSibling, [H, $] = h(L.nextSibling);
        return p(g, c(x, {
          get when() {
            return e().options.toolbar.quote;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Quote),
              get children() {
                return m(wr);
              }
            });
          }
        }), C, T), p(g, c(x, {
          get when() {
            return e().options.toolbar.codeBlock;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.CodeBlock),
              get children() {
                return m(Mr);
              }
            });
          }
        }), S, A), p(g, c(x, {
          get when() {
            return e().options.toolbar.code;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Code),
              get children() {
                return m(Sr);
              }
            });
          }
        }), H, $), g;
      }
    }), D, P), p(d, c(x, {
      get when() {
        return e().options.toolbar.list || e().options.toolbar.orderedList || e().options.toolbar.taskList;
      },
      get children() {
        const g = m(oe), q = g.firstChild, [C, T] = h(q.nextSibling), O = C.nextSibling, [S, A] = h(O.nextSibling), L = S.nextSibling, [H, $] = h(L.nextSibling);
        return p(g, c(x, {
          get when() {
            return e().options.toolbar.list;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.List),
              get children() {
                return m(Cr);
              }
            });
          }
        }), C, T), p(g, c(x, {
          get when() {
            return e().options.toolbar.orderedList;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.OrderedList),
              get children() {
                return m(Lr);
              }
            });
          }
        }), S, A), p(g, c(x, {
          get when() {
            return e().options.toolbar.taskList;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.TaskList),
              get children() {
                return m(jr);
              }
            });
          }
        }), H, $), g;
      }
    }), Y, b), p(d, c(x, {
      get when() {
        return e().options.toolbar.link || e().options.toolbar.image || e().options.toolbar.upload;
      },
      get children() {
        const g = m(oe), q = g.firstChild, [C, T] = h(q.nextSibling), O = C.nextSibling, [S, A] = h(O.nextSibling), L = S.nextSibling, [H, $] = h(L.nextSibling);
        return p(g, c(x, {
          get when() {
            return e().options.toolbar.link;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Link),
              get children() {
                return m(zr);
              }
            });
          }
        }), C, T), p(g, c(x, {
          get when() {
            return e().options.toolbar.image;
          },
          get children() {
            return c(z, {
              onclick: () => o(v.Image),
              get children() {
                return m(Br);
              }
            });
          }
        }), S, A), p(g, c(x, {
          get when() {
            return e().options.toolbar.upload;
          },
          get children() {
            return c(z, {
              onclick: s,
              get children() {
                return [m(Dr), (() => {
                  const te = m(Ar);
                  return qe(r, te), te.addEventListener("change", i), te.style.setProperty("display", "none"), te;
                })()];
              }
            });
          }
        }), H, $), g;
      }
    }), Z, R), a;
  })();
}, ze = 225, $r = (e, t = ze) => {
  const n = Or(e, t), r = Pr(e), o = Tr(e), i = qr(e);
  return [n, r, o, i].join(" | ");
}, qr = (e) => `${Vr(e)} chars`, Tr = (e) => `${Ir(e)} lines`, Or = (e, t = ze) => {
  const n = _r(e, t), r = Math.floor(n), o = Math.floor(n % 1 * 60);
  return r === 0 ? `${o}s read` : `${r}m ${o}s to read`;
}, Pr = (e) => `${st(e)} words`, Vr = (e) => e.length, Ir = (e) => e.split(/\n/).length, _r = (e, t = ze) => st(e) / t, st = (e) => {
  const t = e.replace(/[']/g, "").replace(/[^\w\d]+/g, " ").trim();
  return t ? t.split(/\s+/).length : 0;
}, Wr = /* @__PURE__ */ k('<div class="ink-mde-readability"><span>'), Nr = /* @__PURE__ */ k("<span>&nbsp;|"), Rr = /* @__PURE__ */ k('<div class="ink-mde-attribution"><span>&nbsp;powered by <a class="ink-mde-attribution-link" href="https://github.com/davidmyersdev/ink-mde" rel="noopener noreferrer" target="_blank">ink-mde'), Fr = /* @__PURE__ */ k('<div class="ink-mde-details"><div class="ink-mde-container"><div class="ink-mde-details-content"><!#><!/><!#><!/><!#><!/>'), Ur = () => {
  const [e] = K();
  return (() => {
    const t = m(Fr), n = t.firstChild, r = n.firstChild, o = r.firstChild, [i, s] = h(o.nextSibling), a = i.nextSibling, [l, d] = h(a.nextSibling), f = l.nextSibling, [w, j] = h(f.nextSibling);
    return p(r, c(x, {
      get when() {
        return e().options.readability;
      },
      get children() {
        const M = m(Wr), D = M.firstChild;
        return p(D, () => $r(e().doc)), M;
      }
    }), i, s), p(r, c(x, {
      get when() {
        return gt(() => !!e().options.readability)() && e().options.interface.attribution;
      },
      get children() {
        return m(Nr);
      }
    }), l, d), p(r, c(x, {
      get when() {
        return e().options.interface.attribution;
      },
      get children() {
        return m(Rr);
      }
    }), w, j), t;
  })();
}, Qr = `.ink-mde{border:2px solid var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column)}.ink-mde .cm-cursor{border-left-color:var(--ink-internal-color, inherit);margin-left:0}.ink-mde .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink-mde .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde,.ink-mde .ink-mde-editor{display:flex;flex-direction:column;flex-grow:1;flex-shrink:1;min-height:0}.ink-mde .ink-mde-editor{overflow:auto;padding:.5rem}.ink-mde .ink-mde-toolbar,.ink-mde .ink-mde-details{display:flex;flex-grow:0;flex-shrink:0}.ink-mde .ink-mde-details{background-color:var(--ink-internal-block-background-color);display:flex;padding:.5rem}.ink-mde .ink-mde-details-content{color:inherit;display:flex;filter:brightness(.75);flex-wrap:wrap;font-size:.75em;justify-content:flex-end}.ink-mde .ink-mde-attribution{display:flex;justify-content:flex-end}.ink-mde .ink-mde-attribution-link{color:currentColor;font-weight:600;text-decoration:none}.ink-mde .ink-mde-container{margin-left:auto;margin-right:auto;width:100%}.ink-mde .ink-mde-search-panel{background-color:var(--ink-internal-block-background-color);border-radius:.25rem;padding:.25rem;position:absolute;right:.25rem;top:.25rem;width:clamp(10rem,30%,100%)}.ink-mde .ink-mde-search-panel:focus-within{outline-color:#6495ed;outline-style:solid}.ink-mde .ink-mde-search-input{background-color:transparent;border:none;border-radius:.25rem;color:inherit;font-size:inherit;outline:none;width:100%}.ink-mde .ink-mde-task-toggle{cursor:pointer;height:1rem;line-height:2em;margin:0 .25rem 0 0;position:relative;top:-1px;vertical-align:middle;width:1rem}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-panels{background-color:unset;border:unset;z-index:10}.ink-mde .cm-searchMatch{background-color:#6495ed50}.ink-mde .cm-searchMatch-selected{background-color:#6495edcc}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:nowrap}.ink-mde .cm-lineWrapping{display:flex;flex-direction:column;flex-shrink:1;overflow-wrap:unset;word-break:break-word;white-space:pre-wrap;width:100%;overflow-x:hidden}.ink-mde .cm-line .cm-code,.ink-mde .cm-line .cm-blockquote{word-break:break-all}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line span{display:inline}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);border-left:.25rem solid currentColor;padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}.ink-mde .ink-mde-block-widget-container{padding:.5rem 0}.ink-mde .ink-mde-block-widget{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);padding:var(--ink-internal-block-padding)}
`, Xr = /* @__PURE__ */ k("<style> "), Kr = () => {
  const [e, t] = K(), [n, r] = _(me(e()));
  return Bt(() => {
    r(me(e()));
  }), Ne(() => {
    const o = window.matchMedia("(prefers-color-scheme: dark)"), i = (s) => {
      const {
        editor: a,
        root: l,
        workQueue: d
      } = e();
      l.isConnected ? d.enqueue(async () => {
        const f = await fe([e, t]);
        a.dispatch({
          effects: f
        }), r(me(e()));
      }) : o.removeEventListener("change", i);
    };
    o.addEventListener("change", i);
  }), (() => {
    const o = m(Xr), i = o.firstChild;
    return pe(() => i.data = `.ink {
  ${n().join(`
  `)}
}
${Qr}`), o;
  })();
}, Yr = /* @__PURE__ */ k('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><div class="ink-mde-editor"></div><!#><!/>'), Zr = () => {
  const [e, t] = K(), n = (r) => {
    t(ee(e(), {
      root: r
    }));
  };
  return (() => {
    const r = m(Yr), o = r.firstChild, [i, s] = h(o.nextSibling), a = i.nextSibling, [l, d] = h(a.nextSibling), f = l.nextSibling, [w, j] = h(f.nextSibling), M = w.nextSibling, D = M.nextSibling, [P, V] = h(D.nextSibling);
    return qe(n, r), mt(r, pt(qt), !1, !0), p(r, c(Kr, {}), i, s), p(r, c(x, {
      get when() {
        return e().options.files.clipboard || e().options.files.dragAndDrop;
      },
      get children() {
        return c(pr, {});
      }
    }), l, d), p(r, c(x, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return c(Hr, {});
      }
    }), w, j), p(M, c(kr, {})), p(r, c(x, {
      get when() {
        return e().options.readability || e().options.interface.attribution;
      },
      get children() {
        return c(Ur, {
          store: [e, t]
        });
      }
    }), P, V), ve(), r;
  })();
}, dt = Ct([() => xe(), (e) => typeof e == "function" ? e(xe()) : e]), Jr = (e) => c(dt.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), K = () => Lt(dt), ct = (e) => c(Jr, {
  get store() {
    return e.store;
  },
  get children() {
    return c(Zr, {
      get store() {
        return e.store;
      }
    });
  }
}), Gr = (e, t = {}) => {
  const n = je(t);
  return oo(), ft(() => c(ct, {
    store: n
  }), e), tt(n);
}, eo = (e, t = {}) => e.querySelector($t) ? Gr(e, t) : no(e, t), to = ({
  key: e = "",
  type: t,
  value: n
}) => new Proxy({
  key: e,
  type: t || "default"
}, {
  get: (r, o, i) => o === "value" && !r[o] ? (r.value = n(), Ye(r.value) ? r.value.then((s) => r.value = s) : r.value) : r[o]
}), J = to, no = (e, t = {}) => {
  const n = je(t);
  return ut(() => c(ct, {
    store: n
  }), e), tt(n);
}, ro = (e = {}) => (je(e), ""), oo = () => {
  let e, t;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), t = (n) => n && n.hasAttribute && (n.hasAttribute("data-hk") ? n : t(n.host && n.host instanceof Node ? n.host : n.parentNode)), ["click", "input"].forEach((n) => document.addEventListener(n, (r) => {
    let o = r.composedPath && r.composedPath()[0] || r.target, i = t(o);
    i && !e.completed.has(i) && e.events.push([i, r]);
  })), e.init = (n, r) => {
    e.r[n] = [new Promise((o, i) => r = o), r];
  }, e.set = (n, r, o) => {
    (o = e.r[n]) && o[1](r), e.r[n] = [r];
  }, e.unset = (n) => {
    delete e.r[n];
  }, e.load = (n, r) => {
    if (r = e.r[n])
      return r[0];
  };
}, io = Dt({
  name: "InkMde",
  emits: ["update:modelValue"],
  props: {
    modelValue: {
      type: String
    },
    options: {
      type: Object
    }
  },
  data() {
    return {
      html: "",
      instance: void 0
    };
  },
  watch: {
    modelValue(e) {
      var t, n;
      ((t = this.instance) == null ? void 0 : t.getDoc()) !== e && ((n = this.instance) == null || n.update(e));
    },
    options: {
      deep: !0,
      handler(e, t) {
        var n;
        (n = this.instance) == null || n.reconfigure(e);
      }
    }
  },
  methods: {
    tryInit() {
      var e;
      this.$refs.ink && !this.instance && (this.instance = eo(this.$refs.ink, {
        ...this.options,
        doc: this.modelValue,
        hooks: {
          ...(e = this.options) == null ? void 0 : e.hooks,
          afterUpdate: (t) => {
            var n, r;
            this.$emit("update:modelValue", t), (r = (n = this.options) == null ? void 0 : n.hooks) != null && r.afterUpdate && this.options.hooks.afterUpdate(t);
          }
        }
      }), this.$refs.ink.addEventListener("input", (t) => {
        t.stopPropagation();
      }));
    }
  },
  created() {
    ({}).VITE_SSR && (this.html = ro(this.options));
  },
  mounted() {
    this.tryInit();
  },
  updated() {
    this.tryInit();
  }
}), ao = (e, t) => {
  const n = e.__vccOpts || e;
  for (const [r, o] of t)
    n[r] = o;
  return n;
}, lo = ["innerHTML"];
function so(e, t, n, r, o, i) {
  return At(), Et("div", {
    ref: "ink",
    innerHTML: e.html
  }, null, 8, lo);
}
const vo = /* @__PURE__ */ ao(io, [["render", so]]);
export {
  vo as I,
  U as Q,
  N as W,
  rt as r,
  ue as u
};
//# sourceMappingURL=index-911d402b.js.map
